#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "sources/L1/L1.h"

using namespace std;

static uint8_t pin_user[32] = { // the pin for USER mode access to be set on the SEcube
	't','e','s','t', 0,0,0,0, 0,0,0,0, 0,0,0,0,
	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
};

static uint8_t pin0[32] = { // the default pin on the SEcube is all-zeros
	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
};

static uint8_t test_sn[32] = { // serial number to be written to the SEcube
	1,2,3,4, 5,6,7,8, 9,10,11,12, 13,14,15,16,
	1,2,3,4, 5,6,7,8, 9,10,11,12, 13,14,15,16
};


int main(){

	uint8_t test_data[32] = {
			1,2,3,4, 1,2,3,4, 1,2,3,4, 1,2,3,4,
			1,2,3,4, 1,2,3,4, 1,2,3,4, 1,2,3,4
	};
	se3Key key;

	cout << "Searching for SEcube(s)"<<endl;
	L0 l0 = L0();

	uint8_t numDevices = l0.GetNumberDevices();

	if(numDevices==0){
		cout << "No Devices connected!" << endl;
		return -1;
	} else {
		cout << "Device Found!" << endl;
	}

	L1 l1 = L1(); 	//here the device is opened

	//Factory init, initialize SEcube
	l1.L1FactoryInit(test_sn);

	//First time login as admin with default pin, all 0s
	try{
		l1.L1Login(pin0, SE3_ACCESS_ADMIN, true);
	} catch(...){
		cout << "SEcube already initialized!" << endl;
		return -1;
	}

	//if login fails means device already initialized
	l1.L1SetUserPIN(pin_user);	//set user pin to "test"
	cout << "User PIN set to \"test\" succesfully" << endl;
	l1.L1SetAdminPIN(pin_user); //set admin pin to "test"
	cout << "Admin PIN set to \"test\" succesfully" << endl;

	/***** Add a key *****/
	strcpy((char* )key.name, "TestString");
	key.id = 3;
	key.nameSize = strlen((char *)key.name);
	key.dataSize = 32;
	key.data = test_data;
	key.validity = (uint32_t)time(0) + 365 * 24 * 3600;
	l1.L1KeyEdit(&key,1); //SE3_KEY_OP_UPSERT
	cout << "Key with ID = 3 added successfully" << endl;

	l1.L1Logout();
	l0.L0Close();

	cout << "Initialization completed Successfully" << endl;
	return 0;
}


